import {
	Decimal
} from 'decimal.js';


//过滤频率
function getFrequency(frequencys, frequencyArray) {
	let frequency = new Decimal(frequencys);
	if (frequencyArray.length === 0) {
		frequencyArray.push(frequency);
		return new Decimal('0');
	} else {
		if ((frequency.minus(frequencyArray[0])).abs().lessThan(new Decimal('2'))) {
			let frequencyArrayReturn = frequencyArray[0];
			frequencyArray[0] = frequency;
			return frequencyArrayReturn;
		} else {
			frequencyArray[0] = frequency;
			return new Decimal('0');
		}
	}
}

//计算频率
function computeFrequency(baseFrequency, baseFrequencyType, lv) {
	let baseFrequencyDecimal = new Decimal(baseFrequency.toString());
	if (lv === '三分损益律') {
		return frequencyAndXian(baseFrequencyDecimal, baseFrequencyType);
	} else if (lv === '纯律') {

	} else {

	}
}
//根据基础频率计算每根琴弦的频率
function frequencyAndXian(frequency, type) {
	//以五弦为基础，降低两个八度
	let fiveF = frequency.dividedBy(new Decimal('4'))
	//一弦，five * (16/27)
	let oneF = fiveF.times(new Decimal('16')).dividedBy(new Decimal('27'));
	//二弦，one *  (9/8)
	let twoF = oneF.times(new Decimal('9')).dividedBy(new Decimal('8'));
	//三弦，one * (177147/131072)
	let threeF = oneF.times(new Decimal('177147')).dividedBy(new Decimal('131072'));
	//四弦，one * (3/2)
	let fourF = oneF.times(new Decimal('3')).dividedBy(new Decimal('2'));
	//六弦，one * 2
	let sixF = oneF.times(new Decimal('2'));
	//七弦 two * 2
	let sevenF = twoF.times(new Decimal('2'));
	//紧五弦，5弦降低到降B，先调成正调，然后在降低5弦频率即可，用一弦去算
	if (type === 'six') {
		//one * (59049/32768)
		fiveF = oneF.times(new Decimal('59049')).dividedBy(new Decimal('32768'));
	}
	//紧二五，5弦降低到降B，2弦升到降E
	if (type === 'three') {
		//one * (59049/32768)
		fiveF = oneF.times(new Decimal('59049')).dividedBy(new Decimal('32768'));
		//one * (19683/16384)
		twoF = oneF.times(new Decimal('19683')).dividedBy(new Decimal('16384'));
	}
	//紧二五七，5弦降低到降B，2弦升到降E，7弦升到降e
	if (type === 'four') {
		//one * (59049/32768)
		fiveF = oneF.times(new Decimal('59049')).dividedBy(new Decimal('32768'));
		//one * (19683/16384)
		twoF = oneF.times(new Decimal('19683')).dividedBy(new Decimal('16384'));
		//two * 2
		sevenF = twoF * 2;
	}
	//慢三，3弦降到E
	if (type === 'fifteen') {
		//one * (81/64)
		threeF = oneF.times(new Decimal('81')).dividedBy(new Decimal('64'));
	}
	//慢一三六，3弦降到E，1弦降到B，6弦降到b
	if (type === 'eleven') {
		//one * (81/64)
		threeF = oneF.times(new Decimal('81')).dividedBy(new Decimal('64'));
		//one * (243/128)
		sixF = oneF.times(new Decimal('243')).dividedBy(new Decimal('128'));
		//six * (1/2)
		oneF = sixF.times(new Decimal('0.5'));
	}
	//慢三六，3弦降到E，6弦降到b
	if (type === 'eightteen') {
		//one * (81/64)
		threeF = oneF.times(new Decimal('81')).dividedBy(new Decimal('64'));
		//one * (243/128)
		sixF = oneF.times(new Decimal('243')).dividedBy(new Decimal('128'));
	}
	//慢二弦，二弦等于一弦，
	if (type === 'fourteen') {
		twoF = oneF;
	}
	//紧五慢一，五弦升级到降B，一弦降到降b，即5弦降一个八度
	if (type === 'seven') {
		//one * (59049/32768)
		fiveF = oneF.times(new Decimal('59049')).dividedBy(new Decimal('32768'));
		oneF = fiveF.times(new Decimal('0.5'));
	}

	//紧五慢一二，五弦升级到降B，一弦降到降b，即5弦降一个八度，二弦降低一个大二度音
	if (type === 'onetwofive') {
		//one * (59049/32768)
		fiveF = oneF.times(new Decimal('59049')).dividedBy(new Decimal('32768'));
		twoF = oneF;
		oneF = fiveF.times(new Decimal('0.5'));
	}

	//慢三四六，三弦降到E，四弦降到#F， 六弦降到b
	if (type === 'threefoursix') {
		threeF = oneF.times(new Decimal('81')).dividedBy(new Decimal('64'));
		fourF = oneF.times(new Decimal('729')).dividedBy(new Decimal('512'));;
		sixF = oneF.times(new Decimal('243')).dividedBy(new Decimal('128'));
	}

	console.log("======================" + type + "==========================s");
	console.log("one:" + oneF);
	console.log("two:" + twoF);
	console.log("three:" + threeF);
	console.log("four:" + fourF);
	console.log("five:" + fiveF);
	console.log("six:" + sixF);
	console.log("seven:" + sevenF);
	console.log("======================" + type + "==========================e");
	return {
		oneF: oneF,
		twoF: twoF,
		threeF: threeF,
		fourF: fourF,
		fiveF: fiveF,
		sixF: sixF,
		sevenF: sevenF
	}
}

function musicAlphabetPlan(musicAlphabetBefore) {
	let musicAlphabetFin = [];
	for (let a = 0; a < musicAlphabetBefore.length; a++) {
		let after = '';
		let yin = musicAlphabetBefore[a];
		let zu = yin.split('#');
		if (zu.length > 1) {
			let zuTwo = zu[1].split("1");
			if (zuTwo.length > 1) {
				after = '#' + zuTwo[1].toUpperCase() + '1';
			} else {
				after = '#' + zu[1].toUpperCase();
			}
		} else {
			after = zu[0].toUpperCase();
		}
		musicAlphabetFin.push(after);
	}
	console.log('音名计算后:' +
		musicAlphabetFin[0] + ',' +
		musicAlphabetFin[1] + ',' +
		musicAlphabetFin[2] + ',' +
		musicAlphabetFin[3] + ',' +
		musicAlphabetFin[4] + ',' +
		musicAlphabetFin[5] + ',' +
		musicAlphabetFin[6] + ','
	)
	return musicAlphabetFin;
}


//计算音分值
//ff获取声音频率，checkxian选择琴弦，isAuto是否手动，musicAlphabet调性对应音名，调性基本频率bfBase，三分损益音名顺序musicName，音分差centsRange
function calculateCent(ff, checkxian, isAuto, musicAlphabetBefore, bfBase, musicName, centsRange) {
	console.log("过滤后hz: " + ff.toString());
	let musicAlphabet = musicAlphabetPlan(musicAlphabetBefore)
	let bf = null;
	if (isAuto === 1) { //自动
		//根据频率确定是第几弦
		if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[0].bf))).logarithm(Decimal('2')))).abs().lessThan(
				new Decimal('160'))) {
			checkxian = 1;
			bf = bfBase[0].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[1].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 2;
			bf = bfBase[1].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[2].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 3;
			bf = bfBase[2].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[3].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 4;
			bf = bfBase[3].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[4].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 5;
			bf = bfBase[4].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[5].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 6;
			bf = bfBase[5].bf;
		} else if ((new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[6].bf))).logarithm(Decimal('2')))).abs()
			.lessThan(new Decimal('160'))) {
			checkxian = 7;
			bf = bfBase[6].bf;
		} else if (new Decimal('0').lessThan(new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[0].bf))).logarithm(
				Decimal('2'))))) { //比1弦低
			checkxian = 1;
			bf = bfBase[0].bf;
		} else if (new Decimal('0').times(new Decimal('1200').times((ff.dividedBy(Decimal(bfBase[6].bf))).logarithm(
				Decimal('2'))).lessThan(new Decimal('0')))) { //比7弦高
			checkxian = 7;
			bf = bfBase[6].bf;
		} else {
			console.log('琴弦自动计算错误');
			checkxian = checkxian;
			bf = '-1';
		}
	} else {
		bf = bfBase;
	}
	//计算音分差
	//console.log("ff"+ ff.toString());
	//console.log("bf"+ bf.toString());
	//console.log("ff/bf:"+(ff.dividedBy(bf)).toString());
	//console.log("log2(ff/bf):"+((ff.dividedBy(bf)).logarithm(new Decimal('2'))).toString());
	//console.log("1200*log2(ff/bf):"+(new Decimal('1200').times((ff.dividedBy(bf)).logarithm(Decimal('2'))).toString()));
	let cent = new Decimal('1200').times((ff.dividedBy(bf)).logarithm(new Decimal('2')));
	//确定是弦对应音名
	let music = musicAlphabet[checkxian - 1];
	//确定三分损益几次，音分值补上
	let index = musicName.indexOf(music);
	console.log("index" + index);
	let newCent = cent.plus(new Decimal((index + 1).toString()).times(new Decimal('2')));
	console.log("newCent" + newCent.toString());

	//音分范围
	//console.log("音分范围"+ centsRange.toString());

	let isOk = '0';
	let remark = null;
	//判断弦是否校准
	if (newCent.abs().lessThan(new Decimal(centsRange.toString()))) {
		isOk = '1';
	} else {
		if (newCent.lessThan(new Decimal('0'))) {
			remark = '偏低';
		} else {
			remark = '偏高';
		}
	}
	//返回几弦，是否校准
	return {
		xiansort: checkxian,
		cents: newCent.abs(),
		isOk: isOk,
		remark: remark
	}
}


// 调式数据
const musicType = [{
		type: 'F调 正调', // 调式名称
		isDefault: true, // 是否默认
		musicType: 'one', // 曲库类型
		defaultMusicName: '平沙落雁', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'D', 'F', 'G', 'A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'D', 'F', 'G', 'A', 'c', 'd'
		],
		image: require('@/static/svg/diaoshi_jinerwu.svg') // 旋宫图
	},
	{
		type: '♭B调 紧五 蕤宾调无射均',
		isDefault: false, // 是否默认
		musicType: 'six', // 曲库类型
		defaultMusicName: '潇湘水云', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'D', 'F', 'G', '#A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'D', 'F', 'G', '♭B', 'c', 'd'
		],
		image: require('@/static/svg/diaoshi_jinwu.svg') // 旋宫图
	},

	{
		type: 'C调 慢三 慢角调黄钟均',
		isDefault: false, // 是否默认
		musicType: 'fifteen', // 曲库类型
		defaultMusicName: '风雷引', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'D', 'E', 'G', 'A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'D', 'E', 'G', 'A', 'c', 'd'
		],
		image: require('@/static/svg/diaoshi_mansan.svg') // 旋宫图
	},

	{
		type: '♭B调 紧二五 凄凉调楚商调',
		isDefault: false, // 是否默认
		musicType: 'three', // 曲库类型
		defaultMusicName: '离骚', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', '#D', 'F', 'G', '#A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', '♭E', 'F', 'G', '♭B', 'c', 'd',
		],
		image: require('@/static/svg/diaoshi_jinerwu.svg') // 旋宫图
	}, {
		type: '♭E调 紧二五七 清商调夹钟均',
		isDefault: false, // 是否默认
		musicType: 'four', // 曲库类型
		defaultMusicName: '秋鸿', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', '#D', 'F', 'G', '#A', 'c', '#d'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', '♭E', 'F', 'G', '♭B', 'c', '♭e'
		],
		image: require('@/static/svg/diaoshi_jinerwuqi.svg') // 旋宫图
	}, {
		type: '♭B外调 紧五慢一 黄钟宫调无射调',
		isDefault: false, // 是否默认
		musicType: 'seven', // 曲库类型
		defaultMusicName: '大胡笳', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'#A1', 'D', 'F', 'G', '#A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'♭B1', 'D', 'F', 'G', '♭B', 'c', 'd'
		],
		image: require('@/static/svg/diaoshi_jinwumanyi.svg') // 旋宫图
	}, {
		type: 'G调 慢一三六 慢宫调夷则均林钟均',
		isDefault: false, // 是否默认
		musicType: 'eleven', // 曲库类型
		defaultMusicName: '获麟操', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'B', 'D', 'E', 'G', 'A', 'b', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'B', 'D', 'E', 'G', 'A', 'b', 'd'
		],
		image: require('@/static/svg/diaoshi_manyisanliu.svg') // 旋宫图
	}, {
		type: 'G调 慢三六 无媒调',
		isDefault: false, // 是否默认
		musicType: 'eightteen', // 曲库类型
		defaultMusicName: '孤馆遇神', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'D', 'E', 'G', 'A', 'b', 'd',
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'D', 'E', 'G', 'A', 'b', 'd'
		],
		image: require('@/static/svg/diaoshi_mansanliu.svg') // 旋宫图
	}, {
		type: 'C外调 慢二 慢商调',
		isDefault: false, // 是否默认
		musicType: 'fourteen', // 曲库类型
		defaultMusicName: '广陵散', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'C', 'E', 'G', 'A', 'b', 'd',
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'C', 'E', 'G', 'A', 'b', 'd'
		],
		image: require('@/static/svg/diaoshi_mansanliu.svg') // 旋宫图
	}, {
		type: '♭B调 紧五慢一二 离忧调',
		isDefault: false, // 是否默认
		musicType: 'onetwofive', // 曲库类型
		defaultMusicName: '忘忧', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'#A1', 'C', 'F', 'G', '#A', 'c', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'♭B1', 'C', 'F', 'G', '♭B', 'c', 'd'
		],
		image: require('@/static/svg/diaoshi_mansanliu.svg') // 旋宫图
	}, {
		type: 'D调 慢三四六 侧商调',
		isDefault: false, // 是否默认
		musicType: 'threefoursix', // 曲库类型
		defaultMusicName: '古怨', // 默认显示音名
		// 琴弦对应音名
		musicAlphabet: [
			'C', 'D', 'E', '#F', 'A', 'b', 'd'
		],
		// 仅展示字段 不做数据处理
		musicAlphabetShow: [
			'C', 'D', 'E', '♭G', 'A', 'b', 'd'
		],
		image: require('@/static/svg/diaoshi_mansanliu.svg') // 旋宫图
	}
]
const musicList = [{
		"name": "欸乃", // 曲名
		"nameType": "six" // 关联调式
	},
	{
		"name": "碧涧流泉",
		"nameType": "one"
	},
	{
		"name": "春晓吟",
		"nameType": "one"
	},
	{
		"name": "楚歌",
		"nameType": "three"
	},
	{
		"name": "采茶调",
		"nameType": "one"
	},
	{
		"name": "长清",
		"nameType": "one"
	},
	{
		"name": "沧海龙吟",
		"nameType": "one"
	},
	{
		"name": "长门怨",
		"nameType": "one"
	},
	{
		"name": "春江花月夜",
		"nameType": "one"
	},
	{
		"name": "春风",
		"nameType": "six"
	},
	{
		"name": "洞庭秋思",
		"nameType": "one"
	},
	{
		"name": "大胡笳",
		"nameType": "seven"
	},
	{
		"name": "捣衣-徐立孙",
		"nameType": "four"
	},
	{
		"name": "捣衣-龙琴舫",
		"nameType": "seven"
	},
	{
		"name": "凤求凰",
		"nameType": "one"
	},
	{
		"name": "风雷引",
		"nameType": "fifteen"
	},
	{
		"name": "风云际会",
		"nameType": "one"
	},
	{
		"name": "风雪筑路",
		"nameType": "one"
	}, {
		"name": "古琴吟",
		"nameType": "one"
	},
	{
		"name": "归去来兮",
		"nameType": "one"
	},
	{
		"name": "关山月",
		"nameType": "one"
	},
	{
		"name": "高山",
		"nameType": "one"
	},
	{
		"name": "孤馆遇神",
		"nameType": "eightteen"
	},
	{
		"name": "胡笳十八拍",
		"nameType": "seven"
	},
	{
		"name": "获麟操",
		"nameType": "eleven"
	},
	{
		"name": "精忠词",
		"nameType": "one"
	},
	{
		"name": "极乐吟",
		"nameType": "six"
	},
	{
		"name": "酒狂",
		"nameType": "one"
	},
	{
		"name": "幽兰",
		"nameType": "one"
	},
	{
		"name": "慨古吟",
		"nameType": "one"
	},
	{
		"name": "孔子读易",
		"nameType": "one"
	},
	{
		"name": "渴望",
		"nameType": "six"
	}, {
		"name": "兰花花",
		"nameType": "one"
	},
	{
		"name": "拉纤歌",
		"nameType": "one"
	},
	{
		"name": "良宵引",
		"nameType": "one"
	},
	{
		"name": "龙朔操",
		"nameType": "seven"
	},
	{
		"name": "流水",
		"nameType": "one"
	},
	{
		"name": "离骚",
		"nameType": "three"
	},
	{
		"name": "龙翔操",
		"nameType": "one"
	},
	{
		"name": "楼兰散",
		"nameType": "six"
	}, {
		"name": "满江红",
		"nameType": "one"
	},
	{
		"name": "茉莉花",
		"nameType": "one"
	},
	{
		"name": "梅花三弄",
		"nameType": "one"
	},
	{
		"name": "墨子悲思",
		"nameType": "one"
	},
	{
		"name": "梅园吟",
		"nameType": "six"
	}, {
		"name": "欧鹭忘机",
		"nameType": "one"
	}, {
		"name": "平沙落雁",
		"nameType": "one"
	},
	{
		"name": "普庵咒",
		"nameType": "one"
	},
	{
		"name": "佩兰",
		"nameType": "one"
	}, {
		"name": "秋风词",
		"nameType": "one"
	},
	{
		"name": "清夜吟",
		"nameType": "one"
	},
	{
		"name": "泣颜回",
		"nameType": "six"
	},
	{
		"name": "秋江夜泊",
		"nameType": "fifteen"
	},
	{
		"name": "秋夜长",
		"nameType": "one"
	},
	{
		"name": "秋塞吟",
		"nameType": "one"
	},
	{
		"name": "樵歌",
		"nameType": "one"
	},
	{
		"name": "秋鸿",
		"nameType": "four"
	},
	{
		"name": "双鹤听泉",
		"nameType": "one"
	},
	{
		"name": "石上流泉",
		"nameType": "one"
	},
	{
		"name": "神人畅",
		"nameType": "one"
	},
	{
		"name": "山居吟",
		"nameType": "one"
	},
	{
		"name": "双乙反调",
		"nameType": "six"
	},
	{
		"name": "山水情",
		"nameType": "six"
	},
	{
		"name": "三峡船歌",
		"nameType": "one"
	},
	{
		"name": "水仙操",
		"nameType": "one"
	},
	{
		"name": "搔首问天",
		"nameType": "one"
	},
	{
		"name": "天风环佩",
		"nameType": "one"
	},
	{
		"name": "韦编三绝",
		"nameType": "one"
	},
	{
		"name": "梧叶舞秋风",
		"nameType": "one"
	},
	{
		"name": "乌夜啼",
		"nameType": "one"
	},
	{
		"name": "小白菜",
		"nameType": "one"
	},
	{
		"name": "湘妃怨",
		"nameType": "one"
	},
	{
		"name": "小草",
		"nameType": "one"
	},
	{
		"name": "信天游",
		"nameType": "one"
	},
	{
		"name": "潇湘水云",
		"nameType": "six"
	},
	{
		"name": "玉楼春晓",
		"nameType": "six"
	},
	{
		"name": "映山红",
		"nameType": "six"
	},
	{
		"name": "岳阳三醉",
		"nameType": "one"
	},
	{
		"name": "忆故人",
		"nameType": "one"
	},
	{
		"name": "渔樵问答",
		"nameType": "one"
	},
	{
		"name": "渔歌",
		"nameType": "one"
	},
	{
		"name": "阳春",
		"nameType": "one"
	},
	{
		"name": "幽兰",
		"nameType": "one"
	},
	{
		"name": "醉渔唱晚",
		"nameType": "one"
	},
	{
		"name": "稚朝飞",
		"nameType": "one"
	},
	{
		"name": "广陵散",
		"nameType": "fourteen"
	},
	{
		"name": "忘忧",
		"nameType": "onetwofive"
	},
	{
		"name": "古怨",
		"nameType": "threefoursix"
	}
]


export {
	musicList,
	musicType,
	calculateCent,
	computeFrequency,
	getFrequency
}